package windowsPackage;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Observable;
import java.util.Observer;

import javax.swing.*;

import mainPackage.MainFrame;

public class Booking extends JPanel implements Observer {
	private Booking bookingFrame;
	private JLabel labelSeatsNumber;

	private Integer travelNumber;
	private String from;
	private String to;
	private String departure;
	private String arrival;
	private Integer flightNumber;
	private ArrayList<Integer> bookedSeats;
	private Integer numberOfSeats = 0;
	private JLabel selectedCustomer;
	private String selectedCustomerID;
	
	// Benyttes til at oprette en ny booking
	public Booking(Integer id, Integer flight, String f, String t, String d, String a) {
		bookedSeats = new ArrayList<Integer>();
		travelNumber = id;
		flightNumber = flight;
		from = f;
		to = t;
		departure = d;
		arrival = a;
		bookingFrame = this;
		makeContent();
	}

	//Benyttes nr der skal ndres en allerede eksisterende booking
	public Booking(Integer bookingID, Integer travelID, String seatsID, Integer customerID) {
		makeEditBooking(bookingID, travelID, seatsID, customerID);
	}
	
	//Laver layoutet til ndring af booking
	private void makeEditBooking(Integer bookingID, Integer travelID, String seatsID, Integer customerID) {

		travelNumber = travelID;
		JPanel editBookingPanel = new JPanel(new BorderLayout());
		JPanel textFieldPanel = new JPanel (new GridLayout(0,2));
		JPanel buttonPanel = new JPanel();

		JLabel bookingNrLabel = new JLabel("Booking nr");
		JLabel travelNrLabel = new JLabel("Rejse nr");
		JLabel seatNrLabel = new JLabel("Sde nr");
		JLabel customerNrLabel = new JLabel("Kunde nr");
		final JTextField bookingNrTF = new JTextField(bookingID.toString());
		final JTextField travelNrTF = new JTextField(travelID.toString());
		final JTextField seatNrTF = new JTextField(seatsID);
		final JTextField customerNrTF = new JTextField(customerID.toString());

		bookingNrTF.setEditable(false);
		travelNrTF.setEditable(false);
		seatNrTF.setEditable(false);
		customerNrTF.setEditable(false);


		textFieldPanel.add(bookingNrLabel);
		textFieldPanel.add(bookingNrTF);
		textFieldPanel.add(travelNrLabel);
		textFieldPanel.add(travelNrTF);
		textFieldPanel.add(seatNrLabel);
		textFieldPanel.add(seatNrTF);
		textFieldPanel.add(customerNrLabel);
		textFieldPanel.add(customerNrTF);

		//Sletter bookingen og gr de bookede sder ledige igen og opdaterer antallet af ledige sder p rejsen
		JButton deleteButton = new JButton("Slet booking");
		deleteButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
				int numberOfSeats = 0;
				Database db = new Database();
				String cmd = "DELETE FROM `Booking` WHERE `BookingID` = "+bookingNrTF.getText();
				db.insert(cmd);
				String[] seats = seatNrTF.getText().split("\\s+");
				for(String s : seats) {
					cmd = "UPDATE `Seats` SET Booked = 0 WHERE SeatsID='"+s+"'";
					db.insert(cmd);
					numberOfSeats++;
				}
				cmd = "UPDATE `Travel` SET FreeSeats = FreeSeats + " +  numberOfSeats + " WHERE TravelID='"+ travelNumber +"'";
				db.insert(cmd);

				JOptionPane.showMessageDialog(null, "Booking er slettet!");
				MainFrame.removeContent();
				}
				catch (SQLException e1) {
					JOptionPane.showMessageDialog(null, "Der skete en fejl under oprettelsen af bookingen. \n Fejlkode: " + e1);
				}
			}
		});

		buttonPanel.add(deleteButton);
		editBookingPanel.add(textFieldPanel, BorderLayout.CENTER);
		editBookingPanel.add(buttonPanel, BorderLayout.SOUTH);
		add(editBookingPanel);
	}

	// Benyttes til layoutet for oprettelse afen ny booking. Nsten alt er indtastet i forvejen ud fra den rejse der er valgt, og kan derfor ikke ndres
	private void makeContent() {
		JPanel outerPanel = new JPanel();
		outerPanel.setLayout(new BoxLayout(outerPanel, BoxLayout.Y_AXIS));
		JPanel textPanel = new JPanel(new GridLayout(0,2));

		//Tilfoej labels til textPanel
		textPanel.add(new JLabel("Fra"));
		textPanel.add(new JLabel(from));
		textPanel.add(new JLabel("Til"));
		textPanel.add(new JLabel(to));
		textPanel.add(new JLabel("Afgang"));
		textPanel.add(new JLabel(departure));
		textPanel.add(new JLabel("Ankomst"));
		textPanel.add(new JLabel(arrival));
		textPanel.add(new JLabel("Kunde"));
		//Lav panel til kunde knapper
		JPanel customerButtons = new JPanel(new GridLayout(1,2));
		JButton selectCustomerButton = new JButton("Vlg kunde");
		selectCustomerButton.addActionListener(new SelectCustomerActionListener());
		JButton newCustomerButton = new JButton("Ny kunde");
		newCustomerButton.addActionListener(new NewCustomerActionListener());
		customerButtons.add(newCustomerButton);
		customerButtons.add(selectCustomerButton);
		//Tilbage til labels til textPanel
		textPanel.add(customerButtons);
		textPanel.add(new JLabel("Valgt kunde"));
		selectedCustomer = new JLabel("");
		textPanel.add(selectedCustomer);
		textPanel.add(new JLabel("Antal valgt sder"));
		labelSeatsNumber = new JLabel("0");
		textPanel.add(labelSeatsNumber);
		textPanel.add(new JLabel("Check in"));
		//Lav check in dropdown
		JComboBox checkInCombo = new JComboBox();
		checkInCombo.addItem("Ikke checked in");
		checkInCombo.addItem("Checked in");
		//Tilbage til textPanel
		textPanel.add(checkInCombo);
		//Tilfj til outerPanel
		outerPanel.add(textPanel);

		//Lav knapper
		JPanel buttonPanel = new JPanel();
		buttonPanel.setLayout(new FlowLayout());

		JButton findTravel = new JButton("Find ledige sder");
		findTravel.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				SeatOverview.getInstance(bookingFrame, flightNumber, travelNumber, bookedSeats);
			}
		});

		JButton gem = new JButton("Gem");
		gem.addActionListener(new SaveActionListener());

		buttonPanel.add(findTravel);
		buttonPanel.add(gem);

		outerPanel.add(buttonPanel);

		add(outerPanel);
	}

	@Override
	// Kaldes nr enten SeatOverview klassen eller CustomerSelect klassen har udfrt noget
	public void update(Observable arg0, Object arg1) {
		
		//Hvis arg1 er af typen String, vil stringen indeholde den valgte kundes ID, fornavn og efternavn. Denne string bliver derefter delt op, s navnet kan samles og vises brugeren. ID'et bliver gemt internt i systemet
		if(arg1 instanceof String) {
			String[] parts = ((String) arg1).split(" ");
			selectedCustomer.setText(parts[1] + " " + parts[2]);
			selectedCustomerID = parts[0];
		}
		// Hvis arg1 er af typen ArrayList<?> vil ArrayListen indeholde de valgte sder fra SeatOverview klassen. Disse sde ID'er tlles op s der kan vises det totale antal. Og listen med bookede sder opdateres.
		else if(arg1 instanceof ArrayList<?>) {	
			bookedSeats = (ArrayList<Integer>) arg1;
			numberOfSeats = bookedSeats.size();
			labelSeatsNumber.setText(numberOfSeats.toString());
		}
	}
	// Benytter singleton til at danne en ny CustomerSelect, sender bookingFramen s den kan bruges som observer og 2 da der skal dannes en ny custmer.
	class NewCustomerActionListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			CustomerSelect.getInstance(bookingFrame, 2);
		}
	}
	// Benytter singleton til at danne en ny CustomerSelect, sender bookingFramen s den kan bruges som observer og 1 da der skal sges efter en eksisterende custmer.
	class SelectCustomerActionListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			CustomerSelect.getInstance(bookingFrame, 1);
		}
	}

	class SaveActionListener implements ActionListener {

		@Override
		public void actionPerformed(ActionEvent arg0) {
			try {
				if(selectedCustomerID != null) {
					if(numberOfSeats != 0) {

						// Tller lngden af sde id'erne plus mellemrummet til adskillelse. Dette sikrer, at den string der indsttes i databasen, ikke overstiger grnsen p 100 karakterer.
						int lenghtOfSeatString = 0;
						for(Integer seat : bookedSeats) {
							lenghtOfSeatString += seat.toString().length();
							lenghtOfSeatString++;
						}

						if(lenghtOfSeatString > 100) {
							JOptionPane.showMessageDialog(null, "Der er bestilt flere sder p samme booking, end systemet kan hndtere");
							return;
						}
						//Stter de valgte sder i ArrayListen til booked, og indstter customerID'et til det tilhrende sde
						Database db = new Database();

						Iterator it = bookedSeats.iterator();
						String selectedSeats = "";
						while(it.hasNext()) {
							Integer currentSeat = (Integer) it.next();
							selectedSeats += currentSeat.toString() + " ";
							String cmd = "UPDATE `Seats` SET booked = '1', CustomerID = '" + selectedCustomerID + "' WHERE `SeatsID` = '" + currentSeat + "'";
							db.insert(cmd);
						}
						//Tller antallet af ledige sder p rejsen ned
						String cmd = "UPDATE `Travel` SET FreeSeats = FreeSeats -  " + numberOfSeats + " WHERE TravelID = '" + travelNumber + "'";
						db.insert(cmd);

						// opretter bookingen
						cmd = "INSERT INTO `Booking` (`TravelID`, `SeatsID`, `CustomerID`) VALUES('" + travelNumber + "', '" + selectedSeats + "', '" + selectedCustomerID + "')";
						db.insert(cmd);
						JOptionPane.showMessageDialog(null, "Rejsen er bestilt");
						MainFrame.removeContent();
					}
					else {
						JOptionPane.showMessageDialog(null, "Der skal frst vlges et eller flere sder");
					}
				}
				else {
					JOptionPane.showMessageDialog(null, "Der skal frst vlges en kunde, eller oprettes en ny");
				}
			}
			catch(SQLException e) {
				JOptionPane.showMessageDialog(null, "Det er desvrre ikke muligt at gemme bookingen. \n Fejlkode: " + e);
			}

		}
	}


}