package windowsPackage;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.SwingConstants;

public class Seat extends JLabel {
	private boolean booked;
	private int id;
	private boolean selected = false;
	private int seatSize = 13;
	
	public Seat(int id, Boolean booked, Boolean selected) {
		super("", SwingConstants.CENTER);
		this.id = id;
		this.booked = booked;
		this.selected = selected;
		addMouseListener(new selectMouseListener());
		setOpaque(true);
        repaint();
	}
	
	@Override
	public void paint(Graphics g) {
		setBorder(BorderFactory.createLineBorder(Color.BLACK));
		if(booked) {
			setBackground(Color.RED);
		}
		else if(selected) {
			setBackground(Color.YELLOW);
		}
		else {
			setBackground(Color.GREEN);
		}
		super.paint(g);
	}
	
	@Override
	public Dimension getPreferredSize() {
        return new Dimension(seatSize, seatSize);
    }
    
    @Override
	public Dimension getMinimumSize() {
        return getPreferredSize();
    }
    
    public boolean isSelected() {
    	return selected;
    }
    
    public int getID() {
    	return id;
    }
    
    private class selectMouseListener extends MouseAdapter {

		@Override
		public void mouseClicked(MouseEvent e) {
			if(!booked) {
				selected = !selected;
			}
			repaint();
		}
    	
    }
}
